#include "ngap_pdu_codec.hh"
#include "LibNGAP_TypesAndValues.hh"
#include "asn1/asn_application.h" // from asn1c
#include "loggers.hh"
#include "NGAP_PDU_Descriptions.hh"
#include "TTCN3.hh"
#include <errno.h>
extern "C" {
extern asn_TYPE_descriptor_t asn_DEF_NGAP_PDU;
}
/*extern "C" {
static int asn1c_collect_encoded_data(const void *buffer, size_t size, void *application_specific_key) {
  TTCN_Buffer *tb = (TTCN_Buffer *)application_specific_key;
  tb->put_s(size, (unsigned char *)buffer);
  return 0;
}
}*/

int ngap_pdu_codec::encode(const NGAP__PDU__Descriptions::NGAP__PDU &p_ngap, BITSTRING &p_data) {
	 loggers::get_instance().log("ngap_pdu_codec::encode: ");
	 /*loggers::get_instance().log_msg("ngap_pdu_codec::encodemsg: ",p_ngap);
         TTCN_Buffer buf;
         TTCN_EncDec::set_error_behavior(TTCN_EncDec::ET_ALL, TTCN_EncDec::WARNING);
         p_ngap.encode(NGAP__PDU__Descriptions::NGAP__PDU_descr_, buf, TTCN_EncDec::CT_BER, BER_ENCODE_DER);
	 p_data = oct2bit(OCTETSTRING(buf.get_len(), buf.get_data()));

	 loggers::get_instance().log_msg("ngap_pdu_codec::encodemsg: ",OCTETSTRING(buf.get_len(), buf.get_data()));
        
       	 void *         ptr = NULL;
         asn_dec_rval_t rc_d;

          rc_d = asn_decode(NULL, ATS_BER, (asn_TYPE_descriptor_s *)&asn_DEF_NGAP_PDU, &ptr, buf.get_data(), buf.get_len());
	   if (rc_d.code == RC_OK) {
               // rc   = rc_e.encoded;
	        
	      loggers::get_instance().log("ngap_pdu_codec::ASN1C decoded BER OK: ");
	      // Encode as PER
              asn_enc_rval_t rc_e;
              buf.clear();
               rc_e = asn_encode(NULL,ATS_ALIGNED_BASIC_PER, (asn_TYPE_descriptor_s *)&asn_DEF_NGAP_PDU, ptr, asn1c_collect_encoded_data, &buf);
               //rc_e = asn_encode(NULL,ATS_UNALIGNED_BASIC_PER, (asn_TYPE_descriptor_s *)&asn_DEF_NGAP_PDU, ptr, asn1c_collect_encoded_data, &buf);
               //rc_e = asn_encode(NULL,ATS_ALIGNED_CANONICAL_PER, (asn_TYPE_descriptor_s *)&asn_DEF_NGAP_PDU, ptr, asn1c_collect_encoded_data, &buf);
               //rc_e = asn_encode(NULL,ATS_UNALIGNED_CANONICAL_PER, (asn_TYPE_descriptor_s *)&asn_DEF_NGAP_PDU, ptr, asn1c_collect_encoded_data, &buf);


	       if (rc_e.encoded > 0) { 
	           loggers::get_instance().log("ngap_pdu_codec::ASN1C encoded PER OK: ");
	           loggers::get_instance().log_msg("ngap_pdu_codec::encodemsg PER: ",OCTETSTRING(buf.get_len(), buf.get_data()));
	       }else{

	           //loggers::get_instance().log("ngap_pdu_codec::ASN1C encoded PER NOK:%d %d",rc_e.encoded,errno);
		   switch (errno){
		    case EINVAL:  {loggers::get_instance().log("Incorrect parameters to the function, such as NULLs.");break;}
                    case ENOENT:  {loggers::get_instance().log("Encoding transfer syntax is not defined (for this type)");break;}
                    case EBADF:   {loggers::get_instance().log("The structure has invalid form or content constraint failed.");break;}
                    case EIO:    {loggers::get_instance().log("The (callback) has returned negative value during encoding.");break;}
		   }
	           loggers::get_instance().log("ngap_pdu_codec::ASN1C encoded PER NOK:end switch errno %d",errno);
	       }

          }
          if (ptr) {
             ASN_STRUCT_FREE(asn_DEF_NGAP_PDU, ptr);
          }*/

  return _encode(NGAP__PDU__Descriptions::NGAP__PDU_descr_, asn_DEF_NGAP_PDU, p_ngap, p_data);
}

int ngap_pdu_codec::decode(const BITSTRING &p_data, NGAP__PDU__Descriptions::NGAP__PDU &p_ngap) {
	 loggers::get_instance().log("ngap_pdu_codec::decode: ");
  return  _decode(NGAP__PDU__Descriptions::NGAP__PDU_descr_, asn_DEF_NGAP_PDU, p_data, p_ngap);
}
